
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/poll.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

main()
{
	int itron_out,itron_in;
	int rdbuf_size;
	char rdbuf[256];
	int inbuf_size;
	char inbuf[256];

	if ((itron_in  = open("/dev/itron1", O_RDONLY | O_NONBLOCK )) < 0) {
		fprintf(stderr, "open (%s, O_RDONLY)\n", strerror(errno)); 
	}
	if ((itron_out = open("/dev/itron2", O_WRONLY | O_NONBLOCK)) < 0) {
		fprintf(stderr, "open (%s, O_WRONLY)\n", strerror(errno));
	}

	printf("iTRON interface Start\n");
	if ( 0 == fork()) {
           while(1){
		memset(inbuf, 0x00, sizeof(inbuf[256]));
		inbuf_size = scanf("%s",inbuf);
	     	if (write(itron_out, inbuf, 1) < 0) {
			fprintf(stderr, "write (%d ): %s\n",
				itron_out,  strerror(errno));
		}		
	   }

	} else {
           while(1){
		memset(rdbuf, 0x00, sizeof(rdbuf[256]));
	     	if ((rdbuf_size = read(itron_in, rdbuf, 256)) <= 0) {
			sleep(1);
		} else {
			rdbuf[rdbuf_size] = 00;
			printf("%s", rdbuf);
	   	}
	    }
	}

exit:
	if ((close(itron_in)) != 0) {
		fprintf(stderr, "close (%d): %s\n", itron_in,
			strerror(errno));
	}
	if ((close(itron_out)) != 0) {
		fprintf(stderr, "close (%d): %s\n", itron_out,
			strerror(errno));
	}
}

